<?php
/**********************************************************************************
 *
 * adiImage Fotogalerie
 *
 * v.0.7 - 2007-10-13
 * Copyright 2007 Peter Haunert
 *
 * http://www.netlane.de/adiImage/
 *
 ****************************************************************************
 *        based on: Weatimages 1.7.2, Copyright 2003-2007 Vladimir Nazarkin
 *                  http: *nazarkin.name/projects/weatimages/
 *                  weatimages@nazarkin.name
 ****************************************************************************
 *
 * This file is part of adiImage Fotogalerie.
 *
 * adiImage is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * $Id$
 *
/**********************************************************************************/




function processUpload() {

	if($_FILES['image']['name']) {
		if(!upload()) {
			$phmessage="<span class=\"error\">Error: Image ".$_FILES['image']['name']." could not be upload. <br><br>Possible reasons:<br> - a Chmod Error?<br> - file exists?</span>";
		} else {
			$phmessage="<span class=\"error\">Image ".$_FILES['image']['name']." has been uploaded!</span>";
		}
	} else if($_POST['newalbum']) {
		if(!makedir($_POST['newalbum'])) {
			$phmessage="<span class=\"error\">Error: Folder '".$_POST['newalbum']."' could not be created.<br><br>"
			          ."Possible reasons:<br> - the folder exists already?<br> - you are mischievous?<br> - you don't have writing-rights here?</span>";
		} else {
			$phmessage="<span class=\"error\">Folder '".$_POST['newalbum']."' has been created!</span>";
		}
	}

	// make report
	fatal_error($phmessage);
}



//Uploads the file to the current directory.

// FIXME: resize to max-supported size
function upload() {
	global $ini;

	$tmp = $_FILES['image']['tmp_name'];
	// create a local tmp-file, because we want to resize it also
	$tmp = localTmpfile($tmp);
	if ($tmp === false)
		return false;

	$path = getCurrentPath(false);
	$new = $_FILES['image']['name'];
	$new = jpgName($new);
	$new = $path."/".$new;

	If(is_dir($path)) {
		If(!file_exists($new)) {
			If(!resize_image($tmp, $new, $ini['upload_size'], $ini['upload_quality'])) {
				return false;
			} Else {
				@unlink($tmp);
				return true;
			}
		}
	}
	return false;
}



/**
 * move the tmp-file to a local place for further usage.
 * @return destination-filename
 */
function localTmpfile($filename) {

	$new = getCurrentPath(false)."/" . basename($filename);

	If(!move_uploaded_file($filename, $new))
		return false;

	return $new;
}


/**
 * return true if the file has an accepted image-filename-extension
 */
function isPic($filename) {

	$parts = pathinfo($filename);
	$extensionOk = in_array(strtolower($parts['extension']), array("jpg", "jpeg", "gif", "png"));

	return $extensionOk;
}



/**
 * change a filename so that it has a jpg-extension
 */
function jpgName($filename) {

	// append ext or replace it
	$nparts = split("\.",$filename);
	if (count($nparts) == 1)
		$nparts[1] = "jpg";
	else
		$nparts[count($nparts) - 1] = "jpg";

	return join(".",$nparts);
}



/**
 * Make a directory below current
 */
function makedir($key) {

	$path = getCurrentPath(false);

	if (strpos($key, "..") !== false)
		return false;
	if (strpos($key, "/") !== false)
		return false;
	if (strpos($key, "\\") !== false)
		return false;

	if (!is_dir($path))
		return false;

	if (!is_writable($path))
		return false;

	$key = $path."/".$key;
	if (!@mkdir($key))
		return false;

	@chmod($key,octdec("0777"));

	return true;
}



/**
 * this can fail if the filename has no extension, but the pics should have one...
 */
function getCurrentPath($serverpath = true) {
	global $REQUEST_PATH, $adiPath;
	global $diskPath, $htmlPath; // both set here

	if ($serverpath) {
		if (!empty($htmlPath))
			return $htmlPath;

		$root = $_SERVER['SCRIPT_NAME'];
	} else {
		if (!empty($diskPath))
			return $diskPath;

		$root = dirname($adiPath);
	}

	$parts = pathinfo($REQUEST_PATH);
	if (empty($parts['extension']) && empty($parts['query'])) // its just a path
		$curPath = $root . '/' . $REQUEST_PATH;
	else // its a file
		$curPath = $root . '/' . dirname($REQUEST_PATH);

	if ($serverpath) {
		$htmlPath = $curPath;
	} else {
		$diskPath = $curPath;
	}

	return $curPath;
}


/**
 * load descriptions from desc file if feature enabled and file exists
 */
function load_descriptions($REQUEST_PATH) {
	global $ini;
	$descs = array();
	if ($ini['enable_description']) {
		$desc_filefullname = $REQUEST_PATH . '/' . $ini['description_filename'];
		if (@is_readable($desc_filefullname)) {
			$desc_file = file($desc_filefullname);
			if (is_array($desc_file)) {
				foreach ($desc_file as $line) {
					list($filename, $desc) = split($ini['description_delimiter'], trim($line), 2);
					$descs[$filename] = $desc;
				}//foreach ($desc_file as $line) {
				unset($desc_file);
			}//if (!is_array($desc_file) {
		}//if (@is_readable($desc_filefullname)) {
	}//if ($ini['enable_description']) {
	return $descs;
}



//read directory contents and descriptions
function load_directory($path, $include_index_image) {
	global $ini;

	if ( FALSE == ($dir = opendir($path)) ) {
		fatal_error("Fatal error: path cannot be loaded");
	}
	$pictures = $others = $dirs = array();
	$pictures_mtime = $others_mtime = $dirs_mtime = array();

	$descs = load_descriptions($path);
	//read directory - get arrays with names of objects situated in that directory
	$pictures_count = 0;
	$others_count = 0;
	$dirs_count = 0;

	while (FALSE !== ($file = readdir($dir))) { //sift out directory record which are not necessary images
		if ('.' == $file || '..' == $file) { continue; } //sift out current directory and parental directory
		if (in_array($file, $ini['ignore_files'])) { continue; } //sift out descriptions file
		//don't include hidden objects
		if ( $ini['hidden_prefix'] == substr($file, 0, strlen($ini['hidden_prefix'])) ) { continue; }
		if (is_dir($path . '/' . $file)) { //we got an directory in directory contents listing
			if ($ini['enable_albums_mtime_sort']) {
				$dirs_mtime[$dirs_count] = filemtime($path.'/'.$file);
			}
			$dirs[$dirs_count++] = $file;
			continue;
		}
		//try to find image description (for file without extension) for substituting to absent description (for file with extension)
		if ($ini['enable_omit_ext']) {
			$filename_without_ext = preg_replace('/\.[^\.]+$/', '', $file);
			if (!array_key_exists($file, $descs)) {
				if (array_key_exists($filename_without_ext, $descs)) {
					$descs[$file] = $descs[$filename_without_ext];
				}
			}
			if (!array_key_exists($file.'.', $descs)) {
				if (array_key_exists($filename_without_ext.'.', $descs)) {
					$descs[$file.'.'] = $descs[$filename_without_ext.'.'];
				}
			}
		}//if ($ini['enable_description'] && !array_key_exists($pictures[$i], $descs)) {
		if (preg_match('/\.(' . $ini['thumbnailable_exts'] . ')$/i', $file)) {//include files with image extensions only
			if ($ini['enable_files_mtime_sort']) {
				$pictures_mtime[$pictures_count] = filemtime($path.'/'.$file);
			}
			if ((!$include_index_image && $ini['enable_index_image_hide']) && ($ini['albums_thumbs_index'].'.jpg' == $file || $ini['albums_thumbs_index'].'.jpeg' == $file || $ini['albums_thumbs_index'].'.png' == $file || $ini['albums_thumbs_index'].'.gif' == $file) ) {
				continue;
			}
			$pictures[$pictures_count++] = $file;
			continue;
		}
		if (preg_match('/\.(' . $ini['ignore_exts'] . ')$/i', $file)) {//ignore files with always-dont-show extensions
			continue;
		}
		if ($ini['enable_files_mtime_sort']) {
			$others_mtime[$others_count] = filemtime($path.'/'.$file);
		}
		$others[$others_count++] = $file; //we got an non-image (not thumbnailable) and non-directory item
	}//while (FALSE !== ($file = readdir($dir))) {
	closedir($dir);
	//sort images and other files
	if ($ini['enable_files_mtime_sort']) {
		array_multisort($pictures_mtime, SORT_NUMERIC, (!$ini['enable_files_reverse_sort'])?SORT_ASC:SORT_DESC, $pictures, SORT_STRING, SORT_ASC);
		array_multisort($others_mtime, SORT_NUMERIC, (!$ini['enable_files_reverse_sort'])?SORT_ASC:SORT_DESC, $others, SORT_STRING, SORT_ASC);
	}
	else {
		if (!$ini['enable_files_reverse_sort']) {
			sort($pictures, SORT_STRING);
			sort($others, SORT_STRING);
		} else {
			rsort($pictures, SORT_STRING);
			rsort($others, SORT_STRING);
		}
	}
	//sort albums
	if ($ini['enable_albums_mtime_sort']) {
		array_multisort($dirs_mtime, SORT_NUMERIC, (!$ini['enable_albums_reverse_sort'])?SORT_ASC:SORT_DESC, $dirs, SORT_STRING, SORT_ASC);
	}
	else {
		if (!$ini['enable_albums_reverse_sort']) {
			sort($dirs, SORT_STRING);
		} else {
			rsort($dirs, SORT_STRING);
		}
	}
	return array($pictures, $others, $dirs, $descs);
}//function load_directory($path) {



/**
 * calculate image urls.
 *
 * @return array($uri_original, $uri_resize, $uri_thumb)
 *
 */
function get_image_urls($relative_dir, $filename, $is_need_container) {
	global $ini;

	$uri_thumb = $_SERVER['SCRIPT_NAME'] . '/' . $relative_dir . '/' . $filename . '?action=thumb';

	if ($is_need_container) {
		$uri_original = $_SERVER['SCRIPT_NAME'] . '/' . $relative_dir . '/' . $filename . '?action=big&amp;size=original';
		$uri_resize = $_SERVER['SCRIPT_NAME'] . '/' . $relative_dir . '/' . $filename . '?action=big&amp;size=resize';
	}
	else {
		$current_relative_directory = dirname($_SERVER['SCRIPT_NAME']); //current directory relative to web root
		if ('/' == $current_relative_directory || '\\' == $current_relative_directory) { $current_relative_directory = '/.'; }
		//link to original current image
		$uri_original = $current_relative_directory . '/' . $relative_dir . '/' . $filename;
		//link to resized current image
		$uri_resize = $_SERVER['SCRIPT_NAME'] . '/' . $relative_dir . '/' . $filename . '?action=resize';
		//link to the thumb of current image
	}
	if ($is_need_container) {
		$uri_original = url_compat($uri_original);
	}
	$uri_resize = url_compat($uri_resize);
	$uri_thumb = url_compat($uri_thumb);
	return array($uri_original, $uri_resize, $uri_thumb);
}//function get_image_urls(



//returns filename without extension, '_' symbols replaced by spaces
function clean_filename($filename) {
	global $ini;
	if ($ini['enable_filename_cleaning']) {
		$filename = preg_replace('/\.('.$ini['thumbnailable_exts'].')$/i', '', $filename);
		$filename = preg_replace('/_/', ' ', $filename);
	}
	return $filename;
}//function clean_filename(



//find thumbnail image for album and return array ([0]:uri of thumbnail; [1]:array([0]:thumb width; [1]:thumb height)) or return FALSE if album hasn't thumbnails
function get_album_thumb($album_dir) {
	global $ini;
	$album_thumb[0] = 0;
	list($nested_pictures, /*$others*/, $nested_dirs, $descs) = load_directory($album_dir, TRUE);
	$nested_dirs_count = count($nested_dirs);
	if (0 == count($nested_pictures)) {
		for ($i = 0; $i < $nested_dirs_count; $i++) {
			$album_thumb = get_album_thumb($album_dir.'/'.$nested_dirs[$i]);
			if ($album_thumb[0]) { break; }
		}
	} //if (0 == count($nested_pictures)) {
	else {
		if (in_array($ini['albums_thumbs_index'].'.jpg', $nested_pictures)) {
			$album_index_image = $ini['albums_thumbs_index'].'.jpg';
		}
		elseif (in_array($ini['albums_thumbs_index'].'.jpeg', $nested_pictures)) {
			$album_index_image = $ini['albums_thumbs_index'].'.jpeg';
		}
		elseif (in_array($ini['albums_thumbs_index'].'.png', $nested_pictures)) {
			$album_index_image = $ini['albums_thumbs_index'].'.png';
		}
		elseif (in_array($ini['albums_thumbs_index'].'.gif', $nested_pictures)) {
			$album_index_image = $ini['albums_thumbs_index'].'.gif';
		}
		else {
			$album_index_image = $nested_pictures[0];
		}
		list(/*$uri_original*/, /*$uri_resize*/, $album_thumb[0]) = get_image_urls($album_dir, $album_index_image, 0);
		list(/* $filesize_kb */, $album_thumb_size, /*$resizesize*/, /*$is_resize_senseless*/, /*$exif_comment*/)
			= get_image_sizes($album_dir.'/'.$album_index_image);
		$album_thumb[1] = calc_size_after_resize($album_thumb_size, $ini['thumb_size']);
	} //if (0 == count($nested_pictures)) { ELSE
	return $album_thumb;
}



/**
 * Converts url which use virtual path to url which don't use it
 * Source url must be relative to site root
 * Return the unchanged url if compatibility mode is disabled
 */
function url_compat($url) {
	global $ini;
	if (!$ini['enable_compatibility_mode']) {
		return $url;
	}
	if ( !preg_match ('|^'.$_SERVER['SCRIPT_NAME'].'([^?]*)\??([^?]*)$|', $url, $matches) ) {
		return $url;
	}
	$path = rawurlencode(trim($matches[1], '/'));
	$query_string = $matches[2];
	$url_compatible = $_SERVER['SCRIPT_NAME'];
	if ($path) { $url_compatible .= '?path=' . $path; }
	if ($query_string) { $url_compatible .= (($path)?'&amp;':'?') . $query_string; }
	return $url_compatible;
}



//Get url for navigational link in expanded view (links to neighbour images - previous , next, etc)
//First parameter - path to image, relative to this script
//Returns url to page with image
function get_expanded_navig_url($path_to_image) {

	global $ini;

	if ($ini['enable_size_lookup']) {
		list($filesize_kb, $imagesize, $resizesize, $is_resize_senseless, /*$exif_comment*/) = get_image_sizes($path_to_image);
	}//if ($ini['enable_size_lookup']) {

	list($uri_original, $uri_resize, $uri_thumb) = get_image_urls(dirname($path_to_image), basename($path_to_image), TRUE);

	//if current page contains resized image, but next image cannot be resized, we'll remember that user prefers resized images and when some of next images will be resizeable, we'll show it resized
	if (('resize' == $_GET['size'] || 'resize' == $_GET['preferredsize']) && $is_resize_senseless) {
		$uri_original .= '&amp;preferredsize=resize';
	}

	if (('resize' == $_GET['size'] || 'resize' == $_GET['preferredsize']) && !$is_resize_senseless) {
		$result = $uri_resize;
	} else {
		$result = $uri_original;
	}
	return $result;
}//function get_expanded_navig_url(



function zip_directory($path) {
	global $ini;
	if ('.' != $path) {
		$zip_filename = preg_replace('|/|', '-', $path) . '.zip';
	}
	else {
		$zip_filename = 'Album.zip';
	}
	$zip_fullpath = dirname(__FILE__) . '/' . $ini['cache_dir'] . '/' . $zip_filename;
	$zip_url = 'http://' . $_SERVER["HTTP_HOST"] . dirname($_SERVER['SCRIPT_NAME']) . '/' . $ini['cache_dir'] . '/' . $zip_filename;
	if (!is_file($zip_fullpath)) {
		if (is_writable($ini['cache_dir'])) {
			exec('zip -1Dj "' . $zip_fullpath . '" "' . dirname(__FILE__) . '/' . $path . '/"* -x \*.php \*.css \*.ini \*.db');
		}
		else {
			fatal_error('Cannot create archive within cache directory.');
		}
	}
	header('Location: ' . $zip_url);
}//function zip_directory($path) {



/**
 * create a descriptionsfile from submitted formfields.
 */
function saveDescriptions() {
	global $REQUEST_PATH, $ini;

	$pfx = $ini['descs_prefix'];

	$desc_filefullname = $REQUEST_PATH . '/' . $ini['description_filename'];
	$fp = @fopen($desc_filefullname,"w");
	if ($fp === false) {
		fatal_error("can't write descriptions-file");
	}

	foreach ($_REQUEST as $formFieldName => $formFieldValue) {

		if (substr($formFieldName,0,4) != $pfx)
			continue;

		// clean out as much as possible
		$imgfile =  substr($formFieldName,4);
		$imgfile = strip_tags($imgfile);
		$imgfile = str_replace("",".",$imgfile);
		$imgfile = htmlspecialchars($imgfile);

		// allow some little html inside texts
		$formFieldValue = stripslashes($formFieldValue);
		$formFieldValue = strip_tags($formFieldValue,"<br><b><i>");

		fwrite($fp, $imgfile . " ". $formFieldValue."\n");
	}
	fclose($fp);

	fatal_error("Descriptions saved.");

}








?>